EDIT - bug #9851

Problems during search for updates when network delay is too big
11/04/2021 01:56 PM - Katja Luther

Status: In Progress Start date:

Priority: New Due date:

Assignee: Katja Luther % Done: 0%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 5.45

Severity: normal Found in Version:

Description

Users from mexico does not get the correct informations about new updates, maybe this is because the response needs to long:

mail AM:

kannst du dich darum kiimmern nachzuhaken, woran es liegt. Als erstes missten wir wohl mal sehen, ob es flr das nachste Release
auch nicht klappt. Und ansonsten mal testen, wie empflich die Update Site Funktionalitat auf Delays ist. Hast du so ein Delay Tool
eigentlich installiert. Ware auch griindséatzlich praktisch fiir die Entwicklung. Da sieht man am besten, wo die Performance wirklich
hakt. Wie gesagt, das Editieren auf der Mexico DB war informativ diesbezlglich.

mail AK:
Solche "Delay Tools" kdnnen echte Netzwerklatenz nur unvollstandig simulieren, besser wére es entsprechende Logs des RCP
Updaters zu auf den Clients zu erfassen und diese uns zur Verfligung zu stellen.

Zwei alternative Méglichkeiten:
Vielleicht Iasst sich echte Latenz gut simulieren in dem man

a) das TOR Netzwerk verwendet?
b) einen VPN Service nutzt der in S-Amerika lokalisiert ist

mail AM:

ein VPN in Mexiko (S-Amerika finde ich da nicht so hilfreich) ware sicherlich eine vielversprechende Idee. Vielleicht kénnt ihr ja mal
mit UNAM kléren, ob die da eine Mdglichkeit sehen.
Mit TOR kenne ich mich nicht genligend aus, ob das ausreichend gut ,simuliert”.

,Delay Tools" halte ich trotz gewisser Mangel trotzdem schon mal fir einen wichtigen Schritt. Insbesondere weil man sie sehr einfach
beim Testen von Funktionen mitlaufen lassen kann und das Ergebnis quasi spurt und nicht erst auswerten muss.

Mitloggen von RCP Updater (und allgemein httplnvoker aufrufen) mit mdglichst Ausgabe in einem separaten View steht ja sowieso
schon langer auf der Wunschliste. Das wirde mir sehr oft helfen um zu verstehen, woran es liegen kdnnte, wenn der Editor mal
wieder unresponsive ist.

FUr das jetzige Problem wére dieses Loggen sicherlich erste Wahl.

ich denke wir sollten hier weitermachen. Und sowohl die Delay-Tools als auch das VPN nach Mexiko mal testen.

Katja, kdnntest du dich darum kimmern und Andreas K., kdnntest du ggf. behilflich sein bezlglich Zugang zu den dortigen Rechnern
etc.

Vielleicht sollten wir auch ein Ticket anlegen, in dem wir alles sammeln, falls das noch nicht existiert.

Related issues:
Related to EDIT - bug #5967: Adapt default update site to production update s... Closed

Associated revisions

Revision 70a3ae7c - 11/08/2021 09:41 AM - Katja Luther
ref #9851: change log level

Revision 1620324 - 11/10/2021 01:06 PM - Katja Luther
ref #9851: set proxy

Revision 4394f4a4 - 11/10/2021 01:15 PM - Katja Luther

ref #9851: add org.eclipse.core.net
Revision 6b48abc9 - 11/10/2021 02:10 PM - Katja Luther
ref #9851: minor

Revision 83912d04 - 11/24/2021 01:42 PM - Katja Luther

ref #9851: remove experimental code - continue

Revision e92a852f - 12/01/2021 02:17 PM - Katja Luther

ref #9851: add retry paramater to vm arguments

Revision abd54417 - 12/01/2021 02:27 PM - Katja Luther
ref #9851: code cleaning

Revision cdf554b8 - 12/09/2021 09:28 AM - Katja Luther
ref #9851: change logging

Revision c9aeb938 - 12/09/2021 10:30 AM - Katja Luther
ref #9851: change logging - continue

Revision 365140b4 - 12/09/2021 10:50 AM - Katja Luther
ref #9851: change logger in UpdateHandler

Revision 934cad1f - 12/09/2021 11:07 AM - Katja Luther
ref #9851: change logger in UpdateHandler - continue

Revision 0c4e1698 - 12/09/2021 11:09 AM - Katja Luther
ref #9851: log only update handler - continue

Revision 95d95003 - 12/09/2021 11:35 AM - Katja Luther
ref #9851: log only update handler - minor

Revision 7cc62e59 - 12/14/2021 11:36 AM - Katja Luther
ref #9851: add equinox/p2 to logger configuration

History

#1 - 11/04/2021 03:37 PM - Katja Luther

- Status changed from New to In Progress

The checkForUpdates method shows "No updates available" only if operation.resolveModal(monitor) gives back
Status.STATUS_NOTHING_TO_UPDATE

#2 - 11/05/2021 10:44 AM - Andreas Kohlbecker

- Tags set to mexico

#3 - 11/05/2021 01:42 PM - Andreas Kohlbecker

another option to simulate the situation would be to establish a ssl SOCKS proxy to a server in mexico and to pipe all TaxEditor HTTP/HTTPS traffic
through that proxy:

e https://www.linuxjournal.com/content/use-ssh-create-http-proxy
e https://stackoverflow.com/questions/18147722/how-to-set-the-proxy-configuration-for-a-headless-eclipse-application-on-windows
e http://blog.vogella.com/2009/12/08/eclipse-rcp-proxy-preference/

#4 - 11/08/2021 10:18 AM - Andreas Miiller
Katja Luther wrote:
The checkForUpdates method shows "No updates available" only if operation.resolveModal(monitor) gives back

Status.STATUS_NOTHING_TO_UPDATE

Can you leave a not in which classes these methods are provided?
https://www.linuxjournal.com/content/use-ssh-create-http-proxy
https://stackoverflow.com/questions/18147722/how-to-set-the-proxy-configuration-for-a-headless-eclipse-application-on-windows
http://blog.vogella.com/2009/12/08/eclipse-rcp-proxy-preference/

#5 - 11/08/2021 10:19 AM - Katja Luther

Andreas Muller wrote:
Katja Luther wrote:

The checkForUpdates method shows "No updates available" only if operation.resolveModal(monitor) gives back
Status.STATUS_NOTHING_TO_UPDATE

Can you leave a not in which classes these methods are provided?

eu.etaxonomy.taxeditor.handler.update.UpdateHandler.java

#6 - 11/09/2021 11:42 AM - Katja Luther

Whith no internet connection the message is the same "no updates available", but the log contains an exception.

ENTRY org.eclipse.equinox.p2.transport.ecf 2 0 2021-11-09 11:37:01.929
IMESSAGE Connection to https://cybertaxonomy.eu/download/taxeditor/update/nightly/p2.index failed on cybertaxo
nomy.eu. Retry attempt 0 started
ISTACK O
java.net.UnknownHostException: cybertaxonomy.eu

at java.net.Inetb6AddressImpl.lookupAllHostAddr (Native Method)

at Jjava.net.InetAddress$2.lookupAllHostAddr (Unknown Source)

at java.net.InetAddress.getAddressesFromNameService (Unknown Source)

at java.net.InetAddress.getAllByNameO (Unknown Source)

at java.net.InetAddress.getAllByName (Unknown Source)

at java.net.InetAddress.getAllByName (Unknown Source)

at org.apache.http.impl.conn.SystemDefaultDnsResolver.resolve (SystemDefaultDnsResolver. java:44)

at org.apache.http.impl.conn.DefaultClientConnectionOperator.resolveHostname (DefaultClientConnectionOperat
or.java:259)

at org.apache.http.impl.conn.DefaultClientConnectionOperator.openConnection (DefaultClientConnectionOperato
r.java:159)

at org.apache.http.impl.conn.AbstractPoolEntry.open (AbstractPoolEntry. java:144)

at org.apache.http.impl.conn.AbstractPooledConnAdapter.open (AbstractPooledConnAdapter. java:131)

at org.apache.http.impl.client.DefaultRequestDirector.tryConnect (DefaultRequestDirector.java:611)

at org.apache.http.impl.client.DefaultRequestDirector.execute (DefaultRequestDirector. java:446)

at org.apache.http.impl.client.AbstractHttpClient.doExecute (AbstractHttpClient. java:863)

at org.apache.http.impl.client.CloseableHttpClient.execute (CloseableHttpClient. java:82)

at org.eclipse.ecf.provider.filetransfer.httpclientd4.HttpClientRetrieveFileTransfer.performConnect (HttpCli
entRetrieveFileTransfer.java:1084)

at org.eclipse.ecf.provider.filetransfer.httpclient4.HttpClientRetrieveFileTransfer.access$0 (HttpClientRet
rieveFileTransfer. java:1075)

at org.eclipse.ecf.provider.filetransfer.httpclient4.HttpClientRetrieveFileTransfer$l.performFileTransfer (
HttpClientRetrieveFileTransfer.java:1071)

at org.eclipse.ecf.filetransfer.FileTransferJob.run(FileTransferJob. java:74)

at org.eclipse.core.internal. jobs.Worker.run (Worker. java:55)

#7 - 11/10/2021 10:06 AM - Andreas Kohlbecker
Andreas Kohlbecker wrote:

another option to simulate the situation would be to establish a ss|l SOCKS proxy to a server in mexico and to pipe all TaxEditor HTTP/HTTPS
traffic through that proxy:

° ://www.linuxjournal.com/conten -ssh-cr -http-prox
e https://stackoverflow.com/questions/18147722/how-to-set-the-proxy-configuration-for-a-headless-eclipse-application-on-windows
e http://blog.vogella.com/2009/12/08/eclipse-rcp-proxy-preference/

another good source of information on setting up a SOCKS5 Proxy:
https://ri h.com/penetration-testin rity-tool -ssh-tunnel-

h

#9 - 11/24/2021 11:58 AM - Katja Luther

Using socks proxy can defined by adding
proxyData/SOCKS/hasAuth=false
https://www.linuxjournal.com/content/use-ssh-create-http-proxy
https://stackoverflow.com/questions/18147722/how-to-set-the-proxy-configuration-for-a-headless-eclipse-application-on-windows
http://blog.vogella.com/2009/12/08/eclipse-rcp-proxy-preference/
https://rubysash.com/penetration-testing/security-tools/use-ssh-tunnel-as-socks-proxy-firefox/
https://stackoverflow.com/questions/5857499/how-do-i-configure-the-proxy-settings-so-that-eclipse-can-download-new-plugins
https://docs.oracle.com/javase/8/docs/technotes/guides/net/proxies.html

proxyData/SOCKS/host=127.0.0.1
proxyData/SOCKS/port=8090

in org.eclipse.core.net.prefs (see
https://stackoverflow.com/questions/18147722/how-to-set-the-proxy-configuration-for-a-headless-eclipse-application-on-windows)
or in TaxonomicEditor.ini

#10 - 11/25/2021 11:02 AM - Andreas Kohlbecker

with the following settings in {eclipse-installation-folder}/configuration/.settings/org.eclipse.core.net.prefs

eclipse.preferences.version=1
org.eclipse.core.net.hasMigrated=true
proxyData/SOCKS/hasAuth=false
proxyData/SOCKS/host=localhost
proxyData/SOCKS/port=8090
systemProxiesEnabled=false

eclipse and the TaxEditor are using the configured SOCKS proxy

#11 - 11/25/2021 11:04 AM - Andreas Kohlbecker

NOTE: "Nur die Connect Versuche zum cdm-server gehen Uber den Proxy, die Update-Request gehen einen anderen Weg.

#12 - 12/09/2021 01:33 PM - Katja Luther

Found a possibility to increase the timeout for equinox:

https://wiki.eclipse.org/Equinox/p2/TransportDebugging

and https://bugs.eclipse.org/bugs/show_bug.cqi?id=395696
(this is from 2013 but maybe it helps to solve our problems)

Asked Martin Ricker to add parameters in TaxonomicEditor.ini to increase timeout and retries.

#13 - 03/04/2022 05:11 PM - Andreas Miiller
- Related to bug #5967: Adapt default update site to production update site. added
